<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExisteMoradaAlternativaFornecedor StructType
 * @subpackage Structs
 */
class ExisteMoradaAlternativaFornecedor extends AbstractStructBase
{
    /**
     * The fornecedor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fornecedor;
    /**
     * The morada
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $morada;
    /**
     * Constructor method for ExisteMoradaAlternativaFornecedor
     * @uses ExisteMoradaAlternativaFornecedor::setFornecedor()
     * @uses ExisteMoradaAlternativaFornecedor::setMorada()
     * @param string $fornecedor
     * @param string $morada
     */
    public function __construct($fornecedor = null, $morada = null)
    {
        $this
            ->setFornecedor($fornecedor)
            ->setMorada($morada);
    }
    /**
     * Get fornecedor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFornecedor()
    {
        return isset($this->fornecedor) ? $this->fornecedor : null;
    }
    /**
     * Set fornecedor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fornecedor
     * @return \StructType\ExisteMoradaAlternativaFornecedor
     */
    public function setFornecedor($fornecedor = null)
    {
        // validation for constraint: string
        if (!is_null($fornecedor) && !is_string($fornecedor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fornecedor)), __LINE__);
        }
        if (is_null($fornecedor) || (is_array($fornecedor) && empty($fornecedor))) {
            unset($this->fornecedor);
        } else {
            $this->fornecedor = $fornecedor;
        }
        return $this;
    }
    /**
     * Get morada value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMorada()
    {
        return isset($this->morada) ? $this->morada : null;
    }
    /**
     * Set morada value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $morada
     * @return \StructType\ExisteMoradaAlternativaFornecedor
     */
    public function setMorada($morada = null)
    {
        // validation for constraint: string
        if (!is_null($morada) && !is_string($morada)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($morada)), __LINE__);
        }
        if (is_null($morada) || (is_array($morada) && empty($morada))) {
            unset($this->morada);
        } else {
            $this->morada = $morada;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExisteMoradaAlternativaFornecedor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
